summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRobin H. Johnson <robbat2@gentoo.org>2015-08-08 13:49:04 -0700
committerRobin H. Johnson <robbat2@gentoo.org>2015-08-08 17:38:18 -0700
commit56bd759df1d0c750a065b8c845e93d5dfa6b549d (patch)
tree3f91093cdb475e565ae857f1c5a7fd339e2d781e /eclass/vcs-snapshot.eclass
downloadgentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.gz
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.bz2
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.zip
proj/gentoo: Initial commit
This commit represents a new era for Gentoo: Storing the gentoo-x86 tree in Git, as converted from CVS. This commit is the start of the NEW history. Any historical data is intended to be grafted onto this point. Creation process: 1. Take final CVS checkout snapshot 2. Remove ALL ChangeLog* files 3. Transform all Manifests to thin 4. Remove empty Manifests 5. Convert all stale $Header$/$Id$ CVS keywords to non-expanded Git $Id$ 5.1. Do not touch files with -kb/-ko keyword flags. Signed-off-by: Robin H. Johnson <robbat2@gentoo.org> X-Thanks: Alec Warner <antarus@gentoo.org> - did the GSoC 2006 migration tests X-Thanks: Robin H. Johnson <robbat2@gentoo.org> - infra guy, herding this project X-Thanks: Nguyen Thai Ngoc Duy <pclouds@gentoo.org> - Former Gentoo developer, wrote Git features for the migration X-Thanks: Brian Harring <ferringb@gentoo.org> - wrote much python to improve cvs2svn X-Thanks: Rich Freeman <rich0@gentoo.org> - validation scripts X-Thanks: Patrick Lauer <patrick@gentoo.org> - Gentoo dev, running new 2014 work in migration X-Thanks: Michał Górny <mgorny@gentoo.org> - scripts, QA, nagging X-Thanks: All of other Gentoo developers - many ideas and lots of paint on the bikeshed
Diffstat (limited to 'eclass/vcs-snapshot.eclass')
-rw-r--r--eclass/vcs-snapshot.eclass78
1 files changed, 78 insertions, 0 deletions
diff --git a/eclass/vcs-snapshot.eclass b/eclass/vcs-snapshot.eclass
new file mode 100644
index 000000000000..7e0c3fe3d443
--- /dev/null
+++ b/eclass/vcs-snapshot.eclass
@@ -0,0 +1,78 @@
+# Copyright 1999-2013 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# @ECLASS: vcs-snapshot.eclass
+# @MAINTAINER:
+# mgorny@gentoo.org
+# @BLURB: support eclass for unpacking VCS snapshot tarballs
+# @DESCRIPTION:
+# This eclass provides a convenience src_unpack() which does unpack all
+# the tarballs in SRC_URI to locations matching their (local) names,
+# discarding the original parent directory.
+#
+# The typical use case are VCS snapshots, coming from github, bitbucket
+# and similar services. They have hash appended to the directory name
+# which makes extracting them a painful experience. But if you just use
+# a SRC_URI arrow to rename it (which you're likely have to do anyway),
+# vcs-snapshot will just extract it into a matching directory.
+#
+# Please note that this eclass handles only tarballs (.tar, .tar.gz,
+# .tar.bz2 & .tar.xz). For any other file format (or suffix) it will
+# fall back to regular unpack. Support for additional formats may be
+# added at some point so please keep your SRC_URIs clean.
+#
+# @EXAMPLE:
+#
+# @CODE
+# EAPI=4
+# AUTOTOOLS_AUTORECONF=1
+# inherit autotools-utils vcs-snapshot
+#
+# SRC_URI="http://github.com/example/${PN}/tarball/v${PV} -> ${P}.tar.gz"
+# @CODE
+#
+# and however the tarball was originally named, all files will appear
+# in ${WORKDIR}/${P}.
+
+case ${EAPI:-0} in
+ 0|1|2|3|4|5) ;;
+ *) die "vcs-snapshot.eclass API in EAPI ${EAPI} not yet established."
+esac
+
+EXPORT_FUNCTIONS src_unpack
+
+# @FUNCTION: vcs-snapshot_src_unpack
+# @DESCRIPTION:
+# Extract all the archives from ${A}. The .tar, .tar.gz, .tar.bz2
+# and .tar.xz archives will be unpacked to directories matching their
+# local names. Other archive types will be passed down to regular
+# unpack.
+vcs-snapshot_src_unpack() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local f
+
+ for f in ${A}
+ do
+ case "${f}" in
+ *.tar|*.tar.gz|*.tar.bz2|*.tar.xz)
+ local destdir=${WORKDIR}/${f%.tar*}
+
+ debug-print "${FUNCNAME}: unpacking ${f} to ${destdir}"
+
+ # XXX: check whether the directory structure inside is
+ # fine? i.e. if the tarball has actually a parent dir.
+ mkdir "${destdir}" || die
+ tar -C "${destdir}" -x --strip-components 1 \
+ -f "${DISTDIR}/${f}" || die
+ ;;
+ *)
+ debug-print "${FUNCNAME}: falling back to unpack for ${f}"
+
+ # fall back to the default method
+ unpack "${f}"
+ ;;
+ esac
+ done
+}